use lib::{client::Client, message::{Message, MessageKind}, message_read::MessageReader};
use crossterm::{
    execute,
    terminal::{
        Clear,
        ClearType,
        enable_raw_mode,
        disable_raw_mode
    },
    event::Event,
};

#[allow(unreachable_code)]
#[tokio::main]
pub async fn main() -> anyhow::Result<()> {
    let mut client = Client::connect("127.0.0.1", 8080).await?;
    let local_address = client.stream.local_addr()?;

    // enable_raw_mode()?;
    // execute!(
    //     std::io::stdout(),
    //     Clear(ClearType::All),
    // )?;

    // tokio::task::spawn(async move {
        client.send_message(Message::new(&local_address.to_string(), MessageKind::Test, "test json").unwrap()).await.expect("failed to write to socket");

        // let (mut rd, mut wr) = client.stream.split();

        // let mut message_reader = MessageReader::new();
    
        // 'handler: loop {
        //     let mut buffer = vec![];
        //     if tokio::io::copy(&mut rd, &mut buffer).await.is_err() {
        //         println!("failed to copy");
        //     }


        //     let message =  message_reader.read(&buffer).expect("failed to read from socket");
        //     println!("{:?}", message);

        //     break 'handler;
        // }
    // });
    // client.send_message(Message::new(&local_address.to_string(), MessageKind::Test, "test json").unwrap()).await?;

    // let (mut rd, mut wr) = client.stream.split();

    // let mut message_reader = MessageReader::new();
    
    // 'handler: loop {
    //     let mut buffer = vec![];
    //     if tokio::io::copy(&mut rd, &mut buffer).await.is_err() {
    //         println!("failed to copy");
    //     }

    //     let message =  message_reader.read(&buffer)?;
    //     println!("{:?}", message);

    //     break 'handler;
    // }

    // disable_raw_mode()?;
    Ok(())
}
